#include <sys/cdefs.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fts.h>
#include <string.h>
#include "ls.h"
#include "extern.h"
int
namecmp(const FTSENT *a, const FTSENT *b)
{
	return (strcoll(a->fts_name, b->fts_name));
}
int
revnamecmp(const FTSENT *a, const FTSENT *b)
{
	return (strcoll(b->fts_name, a->fts_name));
}
int
modcmp(const FTSENT *a, const FTSENT *b)
{
	if (b->fts_statp->st_mtime > a->fts_statp->st_mtime)
		return (1);
	if (b->fts_statp->st_mtime < a->fts_statp->st_mtime)
		return (-1);
	return (strcoll(a->fts_name, b->fts_name));
}
int
revmodcmp(const FTSENT *a, const FTSENT *b)
{
	return (modcmp(b, a));
}
int
acccmp(const FTSENT *a, const FTSENT *b)
{
	if (b->fts_statp->st_atime > a->fts_statp->st_atime)
		return (1);
	if (b->fts_statp->st_atime < a->fts_statp->st_atime)
		return (-1);
	return (strcoll(a->fts_name, b->fts_name));
}
int
revacccmp(const FTSENT *a, const FTSENT *b)
{
	return (acccmp(b, a));
}
int
statcmp(const FTSENT *a, const FTSENT *b)
{
	if (b->fts_statp->st_ctime > a->fts_statp->st_ctime)
		return (1);
	if (b->fts_statp->st_ctime < a->fts_statp->st_ctime)
		return (-1);
	return (strcoll(a->fts_name, b->fts_name));
}
int
revstatcmp(const FTSENT *a, const FTSENT *b)
{
	return (statcmp(b, a));
}
int
sizecmp(const FTSENT *a, const FTSENT *b)
{
	if (b->fts_statp->st_size > a->fts_statp->st_size)
		return (1);
	if (b->fts_statp->st_size < a->fts_statp->st_size)
		return (-1);
	return (strcoll(a->fts_name, b->fts_name));
}
int
revsizecmp(const FTSENT *a, const FTSENT *b)
{
	return (sizecmp(b, a));
}
