;;;
;;; Copyright (c) 1989, 1993
;;;	The Regents of the University of California.  All rights reserved.
;;;
;;; This code is derived from software contributed to Berkeley by
;;; Michael Fischbein.
;;;
;;; Redistribution and use in source and binary forms, with or without
;;; modification, are permitted provided that the following conditions
;;; are met:
;;; 1. Redistributions of source code must retain the above copyright
;;;    notice, this list of conditions and the following disclaimer.
;;; 2. Redistributions in binary form must reproduce the above copyright
;;;    notice, this list of conditions and the following disclaimer in the
;;;    documentation and/or other materials provided with the distribution.
;;; 4. Neither the name of the University nor the names of its contributors
;;;    may be used to endorse or promote products derived from this software
;;;    without specific prior written permission.
;;;
;;; THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
;;; ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
;;; IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
;;; ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
;;; FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
;;; DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
;;; OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
;;; HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
;;; LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
;;; OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;;; SUCH DAMAGE.
;;;

(.include <sys/types.h> <sys/stat.h> <fts.h> <string.h> "ls.h" "extern.h")

(define-cise-toplevel (define-cmpfn name . body)
  `(begin
     (define-cfn ,name (a::(const FTSENT*) b::(const FTSENT*)) ::int ,@body)
     (define-cfn ,(string->symbol #`"rev,name") (b::(const FTSENT*) a::(const FTSENT*)) ::int ,@body)))

(define-cise-toplevel (define-cmpfn-stat name member)
  `(define-cmpfn ,name
     (when (> (-> b fts_statp ,member) (-> a fts_statp ,member)) (return 1))
     (when (< (-> b fts_statp ,member) (-> a fts_statp ,member)) (return -1))
     (return (strcoll (-> a fts_name) (-> b fts_name)))))

(define-cmpfn namecmp (return (strcoll (-> a fts_name) (-> b fts_name))))
(define-cmpfn-stat modcmp  st_mtime)
(define-cmpfn-stat acccmp  st_atime)
(define-cmpfn-stat statcmp st_ctime)
(define-cmpfn-stat sizecmp st_size)
